# Author:: Couchbase <info@couchbase.com>
# Copyright:: 2012 Couchbase, Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require File.join(File.dirname(__FILE__), 'setup')

class TestTimer < MiniTest::Test

  def test_initialization
    skip
    num = 0
    cb.run do
      assert Couchbase::Timer.new(connection, 100)  { num += 1}
      assert cb.create_timer(100)           { num += 1}

      assert Couchbase::Timer.new(connection, 100, :periodic => true)  {|t| num += 1; t.cancel}
      assert cb.create_periodic_timer(100)                     {|t| num += 1; t.cancel}
    end
    assert_equal 4, num
  end
end
